todoapp/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from .views import TaskListView, TaskCreateView, TaskUpdateView, TaskDeleteView,task_detail
from . import views

urlpatterns = [
    path('', TaskListView.as_view(), name='task-list'),
    path('create/', TaskCreateView.as_view(), name='task-create'),
    path('<int:pk>/update/', TaskUpdateView.as_view(), name='task-update'),
    path('<int:pk>/delete/', TaskDeleteView.as_view(), name='task-delete'),
    path('login/',views.handleLogin, name='handleLogin'),
    path('logout/', views.handleLogout, name='handleLogout'),
    path('tasks/<int:pk>/detail/', task_detail, name='task-detail'),
]

todoproject/urls.py
from django.contrib import admin
from django.urls import path,include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('tasks/', include('todoapp.urls')),
    path("accounts/", include("django.contrib.auth.urls")),
]

todoapp/models.py
from django.db import models
from django.contrib.auth.models import User

def get_admin_user():
    return User.objects.get(username='admin').id

class Task(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE,null=True, blank=True, default=get_admin_user)
    title = models.CharField(max_length=255)
    description = models.TextField()
    stage_choices = [
        ('todo', 'Todo'),
        ('doing', 'Doing'),
        ('done', 'Done'),
    ]
    stage = models.CharField(max_length=10, choices=stage_choices, default='todo')
    created_at = models.DateTimeField(auto_now_add=True)
    completed_at = models.DateTimeField(null=True, blank=True)
    def __str__(self):
        return self.title

todoapp/views.py
from django.urls import reverse_lazy
from django.views.generic import ListView, CreateView, UpdateView, DeleteView
from .models import Task
from django.http import HttpResponse
from django.contrib.auth import authenticate,login,logout
from django.shortcuts import render, redirect
from django.utils import timezone
from django.shortcuts import render, get_object_or_404


import logging

logger = logging.getLogger(__name__)

class TaskListView(ListView):
    logging.info(f"Tasklist View Home Page")
    model = Task
    template_name = 'task_list.html'
    ordering=['-id']
    def get_queryset(self):
        if self.request.user.is_authenticated:
            logging.info(f"User ${self.request.user} is Authenticated  ")
            return Task.objects.filter(user=self.request.user).order_by('-id')
        else:
            logging.info(f"User is not authenticated  ")
            return Task.objects.none()


class TaskCreateView(CreateView):
    model = Task
    template_name = 'task_form.html'
    fields = ['title', 'description']
    success_url = reverse_lazy('task-list')
    def form_valid(self, form):
        if self.request.user.is_authenticated:
            form.instance.user = self.request.user
            form.instance.stage = 'todo'
            return super().form_valid(form)
        else:
            # Handle the case where the user is not authenticated
            return self.handle_no_permission()

class TaskUpdateView(UpdateView):
    model = Task
    template_name = 'task_form.html'
    fields = ['title', 'description', 'stage']
    success_url = reverse_lazy('task-list')
    def form_valid(self, form):
        task = form.save(commit=False)
        if task.stage == 'done' and not task.completed_at:
            task.completed_at = timezone.now()
        task.save()
        return super().form_valid(form)
    def get_queryset(self):
        if self.request.user.is_authenticated:
            return Task.objects.filter(user=self.request.user)
        else:
            return Task.objects.none()

class TaskDeleteView(DeleteView):
    model = Task
    template_name = 'task_confirm_delete.html'
    success_url = reverse_lazy('task-list')
    def get_queryset(self):
        if self.request.user.is_authenticated:
            return Task.objects.filter(user=self.request.user)
        else:
            return Task.objects.none()


def handleLogin(request):
    if request.method=='POST':
        loginusername=request.POST['username']
        loginpassword=request.POST['password']
        user=authenticate(username=loginusername,password=loginpassword)
        if user is not None:
            login(request,user)
            return redirect('task-list')
        else:
            return redirect('task-list')

    return HttpResponse('handleLogin')
def handleLogout(request):
    
    logout(request)
    return redirect('task-list')
    # return HttpResponse('handleLogout')

def task_detail(request, pk):
    task = get_object_or_404(Task, pk=pk)
    return render(request, 'task_detail.html', {'task': task})

todoapp/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{% block title %}ToDo App{% endblock %}</title>
    <!-- Add your CSS imports or inline styles here -->
</head>
<body>
    <main>
        {% block content %}{% endblock %}
    </main>

    <footer>
        <!-- Add footer content if needed -->
    </footer>

    <!-- Add your JavaScript imports or inline scripts here -->
</body>
</html>

todoapp/templates/login.html
{% extends 'base.html' %} {% block content %}
<section>
  <div class="container">
    <div class="row">
      <div class="col-md-12 col-centered">
        <h1 class="mt-5 mb-3">Login</h1>
      </div>
    </div>
    <div class="row">
      <div class="col-md-6 offset-md-3 mt-3">
        <form method="post" action="tasks/login">
          {% csrf_token %}
          <div class="form-group">
            {{ form.username.label_tag }}
            <input
              type="text"
              name="username"
              class="form-control"
              maxlength="150"
              id="id_username"
              required
            />
          </div>
          <div class="form-group">
            {{ form.password.label_tag }}
            <input
              type="password"
              name="password"
              class="form-control"
              id="id_password"
              required
            />
          </div>
          {% if form.non_field_errors %} {% for error in form.non_field_errors %}
          <p style="font-size: 13px;">
            {{ error|escape }}
          </p>
          {% endfor %} {% endif %}
          <button type="submit" class="btn btn-primary">Login</button>
        </form>
      </div>
    </div>
  </div>
</section>
{% endblock %}

todoapp/templates/register.html
{% extends 'base.html' %} {% block content %}
<section>
  <div class="container">
    <div class="row">
      <div class="col-md-12 col-centered">
        <h1 class="mt-5 mb-3">Register</h1>
      </div>
    </div>
    <div class="row">
      <div class="col-md-6 offset-md-3 mt-3">
        <form method="post" action="{% url 'register' %}">
          {% csrf_token %} {% for field in form %}
          <div class="form-group">
            {{ field.label_tag }}
            <input
              type="{% if 'password' in field.label_tag %}password{% else %}text{% endif %}"
              name="{{ field.html_name }}"
              class="form-control"
              maxlength="{% if 'username' in field.label_tag %}150{% endif %}"
              id="{{ field.id_for_label }}"
              required
            />
          </div>
          {% if field.errors %} {% for error in field.errors %}
          <p style="font-size: 13px;">
            {{ error|escape }}
          </p>
          {% endfor %} {% endif %} {% endfor %}
          <button type="submit" class="btn btn-primary mt-2">Register</button>
        </form>
      </div>
    </div>
  </div>
</section>
{% endblock %}

todoapp/templates/success.html
{% extends 'base.html' %} 
{% block content %}
<section>
  <div class="container">
    <div class="row">
      <div class="col-md-12 col-centered">
        <h1 class="mt-5 mb-3">Login Success!</h1>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12 col-centered mt-3">
        <a href="{% url 'logout' %}" class="btn btn-primary">Logout</a>
      </div>
    </div>
  </div>
</section>
{% endblock %} 

todoapp/templates/task_confirm_delete.html
{% extends 'base.html' %}

{% block content %}
  <h2>Confirm Delete</h2>
  <p>Are you sure you want to delete "{{ object }}"?</p>
  <form method="post" action="">
    {% csrf_token %}
    <button type="submit">Confirm</button>
  </form>
  <a href="{% url 'task-list' %}">Cancel</a>
{% endblock %}

todoapp/templates/task_detail.html
{% extends 'base.html' %}

{% block content %}
  <h2>{{ task.title }} Details</h2>
  <p>Description: {{ task.description }}</p>
  <p>Created: {{ task.created_at|timesince }} ago</p>
  {% if task.completed_at %}
    <p>Completed: {{ task.completed_at|timesince }} ago</p>
  {% endif %}

<br/>
<a href="{% url 'task-list' %}">Back</a>
<br/>
<p><a href="/tasks/logout/">Log Out</a></p>
{% endblock %}

todoapp/templates/task_form.html
{% extends 'base.html' %}

{% block content %}
  <h2>{{ form.instance.title|default:"Create Task" }}</h2>
  <form method="post" action="">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Save</button>
  </form>
{% endblock %}

todoapp/templates/task_list.html
{% extends 'base.html' %}

{% block content %}
{% if user.is_authenticated %}
  <h3>Todo List</h3>
  Hi {{ user.username }}!
  <ul>
    <h3><strong>ToDo</strong></h3>
    {% for task in object_list %}
      {% if task.stage == 'todo' %}
        <li>
          {{ task.title }} |
          <a href="{% url 'task-detail' task.pk %}">Show</a>       
          <a href="{% url 'task-update' task.pk %}">Edit</a>
          <a href="{% url 'task-delete' task.pk %}">Delete</a>
          <small style="font-size: 60%;">Created: {{ task.created_at|timesince }} ago</small>
          {% if task.completed_at %}
          <small style="font-size: 60%;"> , Completed: {{ task.completed_at|timesince }} ago</small>
          {% endif %}
        </li>
      {% endif %}
    {% endfor %}
    </ul>
    <ul>
      <h3><strong>Doing</strong></h3>
    {% for task in object_list %}
      {% if task.stage == 'doing' %}
        <li>
          {{ task.title }} |
          <a href="{% url 'task-detail' task.pk %}">Show</a>
          <a href="{% url 'task-update' task.pk %}">Edit</a>
          <a href="{% url 'task-delete' task.pk %}">Delete</a>
          <small style="font-size: 60%;">Created: {{ task.created_at|timesince}} ago</small>
          {% if task.completed_at %}
          <small style="font-size: 60%;">, Completed: {{ task.completed_at|timesince}} ago</small>
          {% endif %}
        </li>
      {% endif %}
    {% endfor %}
    </ul>
    <ul>
      <h3><strong>Done</strong></h3>
    {% for task in object_list %}
      {% if task.stage == 'done' %}
        <li>
          {{ task.title }} |
          <!-- Edit option disabled for Done tasks -->
          <a href="{% url 'task-detail' task.pk %}">Show</a>
          <a href="{% url 'task-delete' task.pk %}">Delete</a>
          <small style="font-size: 60%;">Created: {{ task.created_at|timesince }} ago</small>
          {% if task.completed_at %}
          <small style="font-size: 60%;"> , Completed: {{ task.completed_at|timesince }} ago</small>
          {% endif %}
        </li>
      {% endif %}
    {% endfor %}
  </ul>
  <a href="{% url 'task-create' %}">Create Task</a><br>
  <p><a href="/tasks/logout/">Log Out</a></p>
  {% else %}
  <p>Login</p>
  <form method="post" action="/tasks/login/">
    {% csrf_token %}
    <div class="form-group">
      {{ form.username.label_tag }}
      <input
        type="text"
        name="username"
        class="form-control"
        maxlength="150"
        id="id_username"
        required
      />
    </div>
    <div class="form-group">
      {{ form.password.label_tag }}
      <input
        type="password"
        name="password"
        class="form-control"
        id="id_password"
        required
      />
    </div>
    {% if form.non_field_errors %} {% for error in form.non_field_errors %}
    <p style="font-size: 13px;">
      {{ error|escape }}
    </p>
    {% endfor %} {% endif %}
    <button type="submit" class="btn btn-primary">Login</button>
  </form>
{% endif %}
{% endblock %}

todoapp/templates/todoapp/task_confirm_delete.html
{% extends 'base.html' %}

{% block content %}
  <h2>Confirm Delete</h2>
  <p>Are you sure you want to delete "{{ object }}"?</p>
  <form method="post" action="">
    {% csrf_token %}
    <button type="submit">Confirm</button>
  </form>
  <a href="{% url 'task-list' %}">Cancel</a>
{% endblock %}

todoapp/templates/todoapp/task_form.html
{% extends 'base.html' %}

{% block content %}
  <h2>{{ form.instance.title|default:"Create Task" }}</h2>
  <form method="post" action="">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Save</button>
  </form>
{% endblock %}

todoapp/templates/todoapp/task_list.html
{% extends 'base.html' %}

{% block content %}
  <h2>Task List</h2>
  <ul>
    {% for task in object_list %}
      <li>{{ task.title }} - {{ task.get_stage_display }}
        <a href="{% url 'task-update' task.pk %}">Edit</a>
        <a href="{% url 'task-delete' task.pk %}">Delete</a>
      </li>
    {% endfor %}
  </ul>
  <a href="{% url 'task-create' %}">Create Task</a>
{% endblock %}